%global svnrev 20
%global vers 0.0
%define roundcubedir %{_datadir}/roundcubemail
%global _logdir /var/log  
%define date   %(echo `C_ALL="C" date +"%a %b %d %Y"`)

Name:          roundcubemail
Epoch:         1
Version:       %{vers}.%{svnrev}
Release:       1.ru
Summary:       RoundCube Webmail, a browser-based multilingual IMAP client
Group:         Applications/System         
License:       GPLv2
URL:           https://oss-services.rutgers.edu/trac/roundcube/
Source0:       %{name}-%{version}.tar.gz
#Source2:       roundcubemail.logrotate
#Source5:    webtools.tar.gz
# Need this since base version isnt caught up yet
#Source6: squirrelmail_usercopy.tar.gz 
# rutgers theme
#Source7: rutgers_theme.tar.gz
# rutgers help
#Source8: help.tar.gz
# plugins
#Source9: reset_prefs.tar.gz
#Source12: listcommands-1.1.tgz
#Source13: zipdownload.tar.gz
#Source15: rutgers_status.tar.gz
#Source19: login_geoip.tar.gz
#Source20: bounce.tar.gz

#Source17: motd.html

#Patch0: roundcubemail-%{version}-labels.inc.patch
#Patch1: roundcubemail-%{version}-ldap.patch

BuildRequires: google-closure-compiler java
BuildArch:     noarch
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root%(%{__id_u} -n)
Requires:      php-mysql 
Requires:      php-pear-Auth-SASL
Requires:      php-pear-DB
# in 1.5 Mail-mimeDecode splits out, so edit below
Requires:      php-pear-Mail-Mime < 1.5
Requires:      php-pear-Net-SMTP
Requires:      php-pear-Net-Socket
Requires:      php, httpd
# in 1.5 Mail-mimeDecode splits out, so edit below
#Requires: php-pear-Mail-mimeDecode
Requires:      php-mcrypt
Requires:      php-pear-MDB2
Requires:      php-pear-MDB2-Driver-mysql
Requires:      php-pear-MDB2-Driver-mysqli 
Requires:      php-pecl-Fileinfo
Requires:      php-xml
Requires:      php-mbstring
Requires:      php-pspell
Requires:      php-ldap
Requires:      webtools
Requires:      php-process
Requires:      GeoIP-data

%description
RoundCube Webmail is a browser-based multilingual IMAP client
with an application-like user interface. It provides full
functionality you expect from an e-mail client, including MIME
support, address book, folder manipulation, message searching
and spell checking. RoundCube Webmail is written in PHP and 
requires the MySQL database or the PostgreSQL database. The user
interface is fully skinnable using XHTML and CSS 2.

#%package webtools
#Summary:        Rutgers roundcube webtools
#Group:          Applications/Internet
#Requires:       %{name} = %{version}-%{release}

#%description webtools
#Rutgers webtools 

#%package plugins
#Summary:        Roundcube plugins
#Group:          Applications/Internet
#Requires:       %{name} = %{version}-%{release}

#%description plugins
#Third-party Roundcube plugins

#%package ru-plugins
#Summary:        Rutgers roundcube plugins
#Group:          Applications/Internet
#Requires:       %{name} = %{version}-%{release}
#Requires: 	php-imap
#Requires: 	php-process

#%description ru-plugins
#Rutgers home-grown Roundcube plugins

%prep
%setup -q -n roundcubemail

# fix permissions and remove any .htaccess files
find . -type f -exec chmod u=rw,go= "{}" \;
find . -name \.htaccess -print | xargs rm -f

# fixup paths to use the right paths
sed -i 's|temp/|${_tmppath}|' config/main.inc.php.dist
sed -i 's|config/|%{_sysconfdir}/roundcubemail/|' config/main.inc.php.dist
sed -i 's|logs/|%{_logdir}/roundcubemail/|' config/main.inc.php.dist
sed -i 's|logs/|%{_logdir}/roundcubemail/|' program/include/main.inc
sed -i 's|config/|%{_sysconfdir}/roundcubemail/|' program/include/main.inc

%build

# compact js

do_shrink() {
   mv $1 $1.src
   google-closure-compiler --compilation_level=SIMPLE_OPTIMIZATIONS --js="$1.src" --js_output_file="$1"
   rm $1.src
}

# shrink roundcube core files

do_shrink "program/js/app.js"
do_shrink "program/js/common.js"
do_shrink "program/js/googiespell.js"
do_shrink "program/js/list.js"

# shrink webtools javascript

FILES=`find plugins/webtools -name *.js`
for i in $FILES; do do_shrink $i; done

%install

rm -rf %{buildroot}
install -d %{buildroot}%{roundcubedir}
cp -pr * %{buildroot}%{roundcubedir}

rm -rf %{buildroot}%{roundcubedir}/installer

#mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
#cp -pr %SOURCE1 %{buildroot}%{_sysconfdir}/httpd/conf.d

mkdir -p %{buildroot}%{_sysconfdir}/roundcubemail
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
#cp -pr %SOURCE2 %{buildroot}%{_sysconfdir}/logrotate.d/roundcubemail

mkdir -p %{buildroot}/var/log/roundcubemail

#cp -pr %SOURCE4 .

#p -pr %SOURCE10 %{buildroot}%{roundcubedir}/program/localization/en_US/
#p -pr %SOURCE11 %{buildroot}%{roundcubedir}/program/js/
#cp -pr %SOURCE16 %{buildroot}%{roundcubedir}/program/js/
#cp -pr %SOURCE17 %{buildroot}%{roundcubedir}/
#p -pr %SOURCE18 %{buildroot}%{roundcubedir}/program/include/

# rutgers rename junk folder  - DONE IN LABELS PATCH
#cd %{buildroot}%{roundcubedir}/program/localization
#find . -name labels.inc -exec sed -i "s:\(\$labels\['junk'\] = \)'.*':\1'AUTO-DELETED-SPAM':g"  '{}' \;
#find . -name labels.inc -exec sed -i "s:\(\$labels\['junk'\]   = \)'.*':\1'AUTO-DELETED-SPAM':g"  '{}' \;
#

cd %{buildroot}%{roundcubedir}/
find . -name \*.swp -type f -delete

#cd %{buildroot}%{roundcubedir}/plugins/
#gzip -dc %{_sourcedir}/webtools.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/squirrelmail_usercopy.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/reset_prefs.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/help.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/login_geoip.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/listcommands-1.1.tgz | tar -xf -
#gzip -dc %{_sourcedir}/zipdownload.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/rutgers_status.tar.gz | tar -xf -
#gzip -dc %{_sourcedir}/bounce.tar.gz | tar -xf -

#cd %{buildroot}%{roundcubedir}/skins/
#gzip -dc %{_sourcedir}/rutgers_theme.tar.gz | tar -xf -

# use dist files as config files
# mv %{buildroot}%{roundcubedir}/config/db.inc.php.dist %{buildroot}%{_sysconfdir}/roundcubemail/db.inc.php
# mv %{buildroot}%{roundcubedir}/config/main.inc.php.dist %{buildroot}%{_sysconfdir}/roundcubemail/main.inc.php
# keep any other config files too
#rm -rf %{buildroot}%{roundcubedir}/config/main.inc.php.dist.orig
mv %{buildroot}%{roundcubedir}/config/* %{buildroot}%{_sysconfdir}/roundcubemail/
mv %{buildroot}%{_sysconfdir}/roundcubemail/main.inc.php %{buildroot}%{_sysconfdir}/roundcubemail/main.inc.php.dist
mv %{buildroot}%{_sysconfdir}/roundcubemail/db.inc.php %{buildroot}%{_sysconfdir}/roundcubemail/db.inc.php.dist

# clean up the buildroot
rm -rf %{buildroot}%{roundcubedir}/{config,logs,temp}
rm -rf %{buildroot}%{roundcubedir}/{CHANGELOG,INSTALL,LICENSE,README,UPGRADING,SQL}

# symlink for config files
ln -s %{_sysconfdir}/roundcubemail/ %{buildroot}%{roundcubedir}/config

%clean
rm -rf %{buildroot}

%post

%files
%defattr(0770,root,apache,-)
%doc 
%{roundcubedir}
%dir %{_sysconfdir}/%{name}
%{_sysconfdir}/%{name}/mimetypes.php
%dir /var/log/roundcubemail
/etc/roundcubemail/main.inc.php.dist
/etc/roundcubemail/main.inc.php.dist.patch
/etc/roundcubemail/db.inc.php.dist

%config(noreplace) %{roundcubedir}/skins/rutgers/templates/content.html
%config(noreplace) %{roundcubedir}/skins/rutgers/templates/header.html
%config(noreplace) %{roundcubedir}/skins/rutgers/templates/footer.html

#%config(noreplace) %{_sysconfdir}/httpd/conf.d/roundcubemail.conf
#%config(noreplace) %{_sysconfdir}/logrotate.d/roundcubemail

%changelog
* %{date} OSS <oss@oss.rutgers.edu> - %{version}-%{release}
- Added extra features to Roundcube4 such as better titlebar, fixed blue resizing, added disk usage graphic etc.
  vverna@nbcs.rutgers.edu
